/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#define MF_SOURCE_NAME  MF_SOURCE_BI_MSG
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 1 "bi_msg.m4"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2008 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "msg.h"

static void *
alloc_msgs()
{
	return xcalloc(NMSGS, sizeof(struct mf_message));
}

static void
destroy_msgs(void *data)
{
	struct mf_message *mtab = data;
	struct mf_message *p;
	for (p = mtab; p < mtab + NMSGS; p++) {
		bi_close_message(p);
	}
	free(mtab);
}


#line 36

#line 36
static int MSGTAB_id;
#line 36 "bi_msg.m4"


static int
find_slot(struct mf_message *tab)
{
	int i;
	for (i = 0; i < NMSGS; i++)
		if (tab[i].msg == NULL)
			return i;
	return -1;
}

static int
do_msg_close(void *item, void *data)
{
	bi_close_message(item);
	return 0;
}

void
bi_close_message(struct mf_message *mp)
{
	if (mp->msg) {
		if (mp->mylist) {
			mu_list_remove(mp->mylist, mp);
			mu_list_destroy(&mp->mylist);
		}
		mu_list_do(mp->msglist, do_msg_close, NULL);
		mu_list_destroy(&mp->msglist);
		free(mp->buf);
		memset(mp, 0, sizeof *mp);
	}
}

int
bi_message_register(eval_environ_t env,
		    mu_list_t msglist, mu_message_t msg, int current)
{
	struct mf_message *msgtab = env_get_builtin_priv(env,MSGTAB_id);
	int idx = find_slot(msgtab);
	if (idx >= 0) {
		struct mf_message *mp = msgtab + idx;
		mp->msg = msg;
		mp->current = current;
		mu_list_create(&mp->mylist);
		mu_list_create(&mp->msglist);
		if (msglist)
			mu_list_append(msglist, mp);
	}
	return idx;
}

int
bi_get_current_message(eval_environ_t env)
{
	int i;
	struct mf_message *tab = env_get_builtin_priv(env,MSGTAB_id);
	for (i = 0; i < NMSGS; i++)
		if (tab[i].msg && tab[i].current)
			return i;
	return -1;
}


#line 111


#line 122


#line 133


/* void message_close(number msg) */
void
#line 136
bi_message_close(eval_environ_t env)
#line 136

#line 136 "bi_msg.m4"
{
#line 136
	
#line 136

#line 136

#line 136
long  nmsg = (long ) get_numeric_arg(env, 0);
#line 136
        
#line 136
        adjust_stack(env, 1);
#line 136

#line 136
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 136
		prog_trace(env, "message_close %lu",nmsg);;
#line 136

{
	
#line 138
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 138
	struct mf_message *mp;
#line 138
			
#line 138
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 138
			env_throw_bi(env, mfe_range, "message_close", _("Invalid message descriptor"))
#line 138
;
#line 138
	mp = mtab + nmsg;
#line 138
		if (!(mp->msg))
#line 138
			env_throw_bi(env, mfe_failure, "message_close", _("Message not open"))
#line 138

#line 138
;
	bi_close_message(mp);
}
}

/* number message_lines(number nmsg) */
void
#line 144
bi_message_lines(eval_environ_t env)
#line 144

#line 144 "bi_msg.m4"
{
#line 144
	
#line 144

#line 144

#line 144
long  nmsg = (long ) get_numeric_arg(env, 0);
#line 144
        
#line 144
        adjust_stack(env, 1);
#line 144

#line 144
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 144
		prog_trace(env, "message_lines %lu",nmsg);;
#line 144

{
	int rc;
	size_t lines;
	
#line 148
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 148
	struct mf_message *mp;
#line 148
			
#line 148
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 148
			env_throw_bi(env, mfe_range, "message_lines", _("Invalid message descriptor"))
#line 148
;
#line 148
	mp = mtab + nmsg;
#line 148
		if (!(mp->msg))
#line 148
			env_throw_bi(env, mfe_failure, "message_lines", _("Message not open"))
#line 148

#line 148
;

	rc = mu_message_lines(mp->msg, &lines);
		if (!(rc == 0))
#line 151
			env_throw_bi(env, mfe_failure, "message_lines", "%s",mu_strerror(rc))
#line 154
;
	
#line 155
do {
#line 155
  push(env, (STKVAL) (lines));
#line 155
  return;
#line 155
} while (0);
}
}

/* number message_body_lines(number nmsg) */
void
#line 160
bi_message_body_lines(eval_environ_t env)
#line 160

#line 160 "bi_msg.m4"
{
#line 160
	
#line 160

#line 160

#line 160
long  nmsg = (long ) get_numeric_arg(env, 0);
#line 160
        
#line 160
        adjust_stack(env, 1);
#line 160

#line 160
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 160
		prog_trace(env, "message_body_lines %lu",nmsg);;
#line 160

{
	int rc;
	size_t lines;
	
#line 164
	
#line 164
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 164
	struct mf_message *mp;
#line 164
			
#line 164
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 164
			env_throw_bi(env, mfe_range, "message_body_lines", _("Invalid message descriptor"))
#line 164
;
#line 164
	mp = mtab + nmsg;
#line 164
		if (!(mp->msg))
#line 164
			env_throw_bi(env, mfe_failure, "message_body_lines", _("Message not open"))
#line 164

#line 164
;
#line 164
	if (!mp->body) {
#line 164
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 164
			if (!(rc == 0))
#line 164
			env_throw_bi(env, mfe_failure, "message_body_lines", "mu_message_get_body: %s",mu_strerror(rc))
#line 164
;
#line 164
	}	  
#line 164
;

	rc = mu_body_lines(mp->body, &lines);
		if (!(rc == 0))
#line 167
			env_throw_bi(env, mfe_failure, "message_body_lines", "%s",mu_strerror(rc))
#line 170
;
	
#line 171
do {
#line 171
  push(env, (STKVAL) (lines));
#line 171
  return;
#line 171
} while (0);
}
}


/* Headers */

/* number message_header_lines(number nmsg) */
void
#line 179
bi_message_header_lines(eval_environ_t env)
#line 179

#line 179 "bi_msg.m4"
{
#line 179
	
#line 179

#line 179

#line 179
long  nmsg = (long ) get_numeric_arg(env, 0);
#line 179
        
#line 179
        adjust_stack(env, 1);
#line 179

#line 179
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 179
		prog_trace(env, "message_header_lines %lu",nmsg);;
#line 179

{
	int rc;
	size_t lines;
	
#line 183
	
#line 183
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 183
	struct mf_message *mp;
#line 183
			
#line 183
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 183
			env_throw_bi(env, mfe_range, "message_header_lines", _("Invalid message descriptor"))
#line 183
;
#line 183
	mp = mtab + nmsg;
#line 183
		if (!(mp->msg))
#line 183
			env_throw_bi(env, mfe_failure, "message_header_lines", _("Message not open"))
#line 183

#line 183
;
#line 183
	if (!mp->hdr) {
#line 183
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 183
			if (!(rc == 0))
#line 183
			env_throw_bi(env, mfe_failure, "message_header_lines", "mu_message_get_header: %s",mu_strerror(rc))
#line 183
;
#line 183
	}	  
#line 183
;

	rc = mu_header_lines(mp->hdr, &lines);
		if (!(rc == 0))
#line 186
			env_throw_bi(env, mfe_failure, "message_header_lines", "%s",mu_strerror(rc))
#line 189
;
	
#line 190
do {
#line 190
  push(env, (STKVAL) (lines));
#line 190
  return;
#line 190
} while (0);
}
}

/* number message_header_count(number nmsg) */
void
#line 195
bi_message_header_count(eval_environ_t env)
#line 195

#line 195 "bi_msg.m4"
{
#line 195
	
#line 195

#line 195

#line 195
long  nmsg = (long ) get_numeric_arg(env, 0);
#line 195
        
#line 195
        adjust_stack(env, 1);
#line 195

#line 195
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 195
		prog_trace(env, "message_header_count %lu",nmsg);;
#line 195

{
	int rc;
	size_t count;
	
#line 199
	
#line 199
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 199
	struct mf_message *mp;
#line 199
			
#line 199
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 199
			env_throw_bi(env, mfe_range, "message_header_count", _("Invalid message descriptor"))
#line 199
;
#line 199
	mp = mtab + nmsg;
#line 199
		if (!(mp->msg))
#line 199
			env_throw_bi(env, mfe_failure, "message_header_count", _("Message not open"))
#line 199

#line 199
;
#line 199
	if (!mp->hdr) {
#line 199
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 199
			if (!(rc == 0))
#line 199
			env_throw_bi(env, mfe_failure, "message_header_count", "mu_message_get_header: %s",mu_strerror(rc))
#line 199
;
#line 199
	}	  
#line 199
;

	rc = mu_header_get_field_count(mp->hdr, &count);
		if (!(rc == 0))
#line 202
			env_throw_bi(env, mfe_failure, "message_header_count", "%s",mu_strerror(rc))
#line 205
;
	
#line 206
do {
#line 206
  push(env, (STKVAL) (count));
#line 206
  return;
#line 206
} while (0);
}
}

/* bool message_has_header(number msg, string header[, number idx]) */
void
#line 211
bi_message_has_header(eval_environ_t env)
#line 211

#line 211 "bi_msg.m4"
{
#line 211
	
#line 211

#line 211
long __bi_argcnt = (long)get_numeric_arg(env, 0);
#line 211
long  nmsg = (long ) get_numeric_arg(env, 1);
#line 211
        char * header = (char *) get_string_arg(env, 2);
#line 211
        long  idx = (long ) get_numeric_arg(env, 3);
#line 211
        
#line 211
        adjust_stack(env, __bi_argcnt + 1);
#line 211

#line 211
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 211
		prog_trace(env, "message_has_header %lu %s %lu",nmsg, header, ((__bi_argcnt > 2) ? idx : 0));;

{
	int rc;
	const char *val;
	
#line 216
	
#line 216
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 216
	struct mf_message *mp;
#line 216
			
#line 216
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 216
			env_throw_bi(env, mfe_range, "message_has_header", _("Invalid message descriptor"))
#line 216
;
#line 216
	mp = mtab + nmsg;
#line 216
		if (!(mp->msg))
#line 216
			env_throw_bi(env, mfe_failure, "message_has_header", _("Message not open"))
#line 216

#line 216
;
#line 216
	if (!mp->hdr) {
#line 216
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 216
			if (!(rc == 0))
#line 216
			env_throw_bi(env, mfe_failure, "message_has_header", "mu_message_get_header: %s",mu_strerror(rc))
#line 216
;
#line 216
	}	  
#line 216
;

	rc = mu_header_sget_value_n(mp->hdr, header, ((__bi_argcnt > 2) ? idx : 1), &val);
 	
#line 219
do {
#line 219
  push(env, (STKVAL) (rc == 0));
#line 219
  return;
#line 219
} while (0);
}
}

/* string message_find_header(number msg, string header[, number idx]) */
void
#line 224
bi_message_find_header(eval_environ_t env)
#line 224

#line 224 "bi_msg.m4"
{
#line 224
	
#line 224

#line 224
long __bi_argcnt = (long)get_numeric_arg(env, 0);
#line 224
long  nmsg = (long ) get_numeric_arg(env, 1);
#line 224
        char * header = (char *) get_string_arg(env, 2);
#line 224
        long  idx = (long ) get_numeric_arg(env, 3);
#line 224
        
#line 224
        adjust_stack(env, __bi_argcnt + 1);
#line 224

#line 224
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 224
		prog_trace(env, "message_find_header %lu %s %lu",nmsg, header, ((__bi_argcnt > 2) ? idx : 0));;

{
	int rc;
	const char *val;
	
#line 229
	
#line 229
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 229
	struct mf_message *mp;
#line 229
			
#line 229
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 229
			env_throw_bi(env, mfe_range, "message_find_header", _("Invalid message descriptor"))
#line 229
;
#line 229
	mp = mtab + nmsg;
#line 229
		if (!(mp->msg))
#line 229
			env_throw_bi(env, mfe_failure, "message_find_header", _("Message not open"))
#line 229

#line 229
;
#line 229
	if (!mp->hdr) {
#line 229
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 229
			if (!(rc == 0))
#line 229
			env_throw_bi(env, mfe_failure, "message_find_header", "mu_message_get_header: %s",mu_strerror(rc))
#line 229
;
#line 229
	}	  
#line 229
;

	rc = mu_header_sget_value_n(mp->hdr, header, ((__bi_argcnt > 2) ? idx : 1), &val);
	if (rc == MU_ERR_NOENT)
			env_throw_bi(env, mfe_not_found, "message_find_header", _("Header not found"));
	else if (rc)
			env_throw_bi(env, mfe_failure, "message_find_header", "%s",mu_strerror(rc));
	do {pushs(env, val);
#line 236
return;
#line 236
} while (0);
}
}


/* Multipart messages */

/* bool message_is_multipart(number msg) */
void
#line 244
bi_message_is_multipart(eval_environ_t env)
#line 244

#line 244 "bi_msg.m4"
{
#line 244
	
#line 244

#line 244

#line 244
long  nmsg = (long ) get_numeric_arg(env, 0);
#line 244
        
#line 244
        adjust_stack(env, 1);
#line 244

#line 244
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 244
		prog_trace(env, "message_is_multipart %lu",nmsg);;
#line 244

{
	int rc, res;
	
#line 247
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 247
	struct mf_message *mp;
#line 247
			
#line 247
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 247
			env_throw_bi(env, mfe_range, "message_is_multipart", _("Invalid message descriptor"))
#line 247
;
#line 247
	mp = mtab + nmsg;
#line 247
		if (!(mp->msg))
#line 247
			env_throw_bi(env, mfe_failure, "message_is_multipart", _("Message not open"))
#line 247

#line 247
;

	rc = mu_message_is_multipart(mp->msg, &res);
		if (!(rc == 0))
#line 250
			env_throw_bi(env, mfe_failure, "message_is_multipart", "%s",mu_strerror(rc))
#line 253
;
	
#line 254
do {
#line 254
  push(env, (STKVAL) (res));
#line 254
  return;
#line 254
} while (0);
}
}

/* number message_count_parts(number msg) */
void
#line 259
bi_message_count_parts(eval_environ_t env)
#line 259

#line 259 "bi_msg.m4"
{
#line 259
	
#line 259

#line 259

#line 259
long  nmsg = (long ) get_numeric_arg(env, 0);
#line 259
        
#line 259
        adjust_stack(env, 1);
#line 259

#line 259
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 259
		prog_trace(env, "message_count_parts %lu",nmsg);;
#line 259

{
	int rc;
	size_t count;
	
#line 263
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 263
	struct mf_message *mp;
#line 263
			
#line 263
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 263
			env_throw_bi(env, mfe_range, "message_count_parts", _("Invalid message descriptor"))
#line 263
;
#line 263
	mp = mtab + nmsg;
#line 263
		if (!(mp->msg))
#line 263
			env_throw_bi(env, mfe_failure, "message_count_parts", _("Message not open"))
#line 263

#line 263
;
	rc = mu_message_get_num_parts(mp->msg, &count);
		if (!(rc == 0))
#line 265
			env_throw_bi(env, mfe_failure, "message_count_parts", "%s",mu_strerror(rc))
#line 268
;
	
#line 269
do {
#line 269
  push(env, (STKVAL) (count));
#line 269
  return;
#line 269
} while (0);
}
}

/* number message_get_part(number msg, number idx) */
void
#line 274
bi_message_get_part(eval_environ_t env)
#line 274

#line 274 "bi_msg.m4"
{
#line 274
	
#line 274

#line 274

#line 274
long  nmsg = (long ) get_numeric_arg(env, 0);
#line 274
        long  idx = (long ) get_numeric_arg(env, 1);
#line 274
        
#line 274
        adjust_stack(env, 2);
#line 274

#line 274
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 274
		prog_trace(env, "message_get_part %lu %lu",nmsg, idx);;
#line 274

{
	int rc;
	mu_message_t msg;
	
#line 278
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 278
	struct mf_message *mp;
#line 278
			
#line 278
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 278
			env_throw_bi(env, mfe_range, "message_get_part", _("Invalid message descriptor"))
#line 278
;
#line 278
	mp = mtab + nmsg;
#line 278
		if (!(mp->msg))
#line 278
			env_throw_bi(env, mfe_failure, "message_get_part", _("Message not open"))
#line 278

#line 278
;

	rc = mu_message_get_part(mp->msg, idx, &msg);
		if (!(rc == 0))
#line 281
			env_throw_bi(env, mfe_failure, "message_get_part", "%s",mu_strerror(rc))
#line 284
;
	rc = bi_message_register(env, mp->msglist, msg, 0);
		if (!(rc >= 0))
#line 286
			env_throw_bi(env, mfe_failure, "message_get_part", _("No more message slots available"))
#line 288
;
	
#line 289
do {
#line 289
  push(env, (STKVAL) (rc));
#line 289
  return;
#line 289
} while (0);
}
}


/* Reading */

/* string message_rewind(number nmsg) */
void
#line 297
bi_message_rewind(eval_environ_t env)
#line 297

#line 297 "bi_msg.m4"
{
#line 297
	
#line 297

#line 297

#line 297
long  nmsg = (long ) get_numeric_arg(env, 0);
#line 297
        
#line 297
        adjust_stack(env, 1);
#line 297

#line 297
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 297
		prog_trace(env, "message_rewind %lu",nmsg);;
#line 297

{
	int rc;
	mu_stream_t str;
	
#line 301
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 301
	struct mf_message *mp;
#line 301
			
#line 301
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 301
			env_throw_bi(env, mfe_range, "message_rewind", _("Invalid message descriptor"))
#line 301
;
#line 301
	mp = mtab + nmsg;
#line 301
		if (!(mp->msg))
#line 301
			env_throw_bi(env, mfe_failure, "message_rewind", _("Message not open"))
#line 301

#line 301
;
	rc = mu_message_get_stream(mp->msg, &str);
		if (!(rc == 0))
#line 303
			env_throw_bi(env, mfe_failure, "message_rewind", "mu_message_get_stream: %s",mu_strerror(rc))
#line 306
;
	rc = mu_stream_seek(str, 0, SEEK_SET);
		if (!(rc == 0))
#line 308
			env_throw_bi(env, mfe_failure, "message_rewind", "mu_stream_seek: %s",mu_strerror(rc))
#line 311
;
}
}

/* string message_read_line(number nmsg) */
void
#line 316
bi_message_read_line(eval_environ_t env)
#line 316

#line 316 "bi_msg.m4"
{
#line 316
	
#line 316

#line 316

#line 316
long  nmsg = (long ) get_numeric_arg(env, 0);
#line 316
        
#line 316
        adjust_stack(env, 1);
#line 316

#line 316
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 316
		prog_trace(env, "message_read_line %lu",nmsg);;
#line 316

{
	int rc;
	mu_stream_t str;
	size_t size;
	
#line 321
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 321
	struct mf_message *mp;
#line 321
			
#line 321
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 321
			env_throw_bi(env, mfe_range, "message_read_line", _("Invalid message descriptor"))
#line 321
;
#line 321
	mp = mtab + nmsg;
#line 321
		if (!(mp->msg))
#line 321
			env_throw_bi(env, mfe_failure, "message_read_line", _("Message not open"))
#line 321

#line 321
;

	rc = mu_message_get_stream(mp->msg, &str);
		if (!(rc == 0))
#line 324
			env_throw_bi(env, mfe_failure, "message_read_line", "mu_message_get_stream: %s",mu_strerror(rc))
#line 327
;
	rc = mu_stream_sequential_getline(str, &mp->buf, &mp->bufsize, &size);
		if (!(rc == 0))
#line 329
			env_throw_bi(env, mfe_io, "message_read_line", "mu_stream_sequential_getline: %s",mu_strerror(rc))
#line 332
;
		if (!(size > 0))
#line 333
			env_throw_bi(env, mfe_not_found, "message_read_line", /* FIXME: Should be mfe_eof */
		  "mu_stream_sequential_getline: %s",_("end of input"))
#line 336
;
	do {pushs(env, mp->buf);
#line 337
return;
#line 337
} while (0);
}
}

/* string message_body_rewind(number nmsg) */
void
#line 342
bi_message_body_rewind(eval_environ_t env)
#line 342

#line 342 "bi_msg.m4"
{
#line 342
	
#line 342

#line 342

#line 342
long  nmsg = (long ) get_numeric_arg(env, 0);
#line 342
        
#line 342
        adjust_stack(env, 1);
#line 342

#line 342
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 342
		prog_trace(env, "message_body_rewind %lu",nmsg);;
#line 342

{
	int rc;
	mu_stream_t str;
	
#line 346
	
#line 346
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 346
	struct mf_message *mp;
#line 346
			
#line 346
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 346
			env_throw_bi(env, mfe_range, "message_body_rewind", _("Invalid message descriptor"))
#line 346
;
#line 346
	mp = mtab + nmsg;
#line 346
		if (!(mp->msg))
#line 346
			env_throw_bi(env, mfe_failure, "message_body_rewind", _("Message not open"))
#line 346

#line 346
;
#line 346
	if (!mp->body) {
#line 346
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 346
			if (!(rc == 0))
#line 346
			env_throw_bi(env, mfe_failure, "message_body_rewind", "mu_message_get_body: %s",mu_strerror(rc))
#line 346
;
#line 346
	}	  
#line 346
;
	rc = mu_body_get_stream(mp->body, &str);
		if (!(rc == 0))
#line 348
			env_throw_bi(env, mfe_failure, "message_body_rewind", "mu_message_get_stream: %s",mu_strerror(rc))
#line 351
;
	rc = mu_stream_seek(str, 0, SEEK_SET);
		if (!(rc == 0))
#line 353
			env_throw_bi(env, mfe_failure, "message_body_rewind", "mu_stream_seek: %s",mu_strerror(rc))
#line 356
;
}
}

/* string message_read_body_line(number msg)  */
void
#line 361
bi_message_read_body_line(eval_environ_t env)
#line 361

#line 361 "bi_msg.m4"
{
#line 361
	
#line 361

#line 361

#line 361
long  nmsg = (long ) get_numeric_arg(env, 0);
#line 361
        
#line 361
        adjust_stack(env, 1);
#line 361

#line 361
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 361
		prog_trace(env, "message_read_body_line %lu",nmsg);;
#line 361

{
	int rc;
	mu_stream_t str;
	size_t size;
	
#line 366
	
#line 366
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 366
	struct mf_message *mp;
#line 366
			
#line 366
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 366
			env_throw_bi(env, mfe_range, "message_read_body_line", _("Invalid message descriptor"))
#line 366
;
#line 366
	mp = mtab + nmsg;
#line 366
		if (!(mp->msg))
#line 366
			env_throw_bi(env, mfe_failure, "message_read_body_line", _("Message not open"))
#line 366

#line 366
;
#line 366
	if (!mp->body) {
#line 366
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 366
			if (!(rc == 0))
#line 366
			env_throw_bi(env, mfe_failure, "message_read_body_line", "mu_message_get_body: %s",mu_strerror(rc))
#line 366
;
#line 366
	}	  
#line 366
;
	
	rc = mu_body_get_stream(mp->body, &str);
		if (!(rc == 0))
#line 369
			env_throw_bi(env, mfe_failure, "message_read_body_line", "mu_body_get_stream: %s",mu_strerror(rc))
#line 372
;
	rc = mu_stream_sequential_getline(str, &mp->buf, &mp->bufsize, &size);
		if (!(rc == 0))
#line 374
			env_throw_bi(env, mfe_io, "message_read_body_line", "mu_stream_sequential_getline: %s",mu_strerror(rc))
#line 377
;
		if (!(size > 0))
#line 378
			env_throw_bi(env, mfe_not_found, "message_read_body_line", /* FIXME: Should be mfe_eof */
		  "mu_stream_sequential_getline: %s",_("end of input"))
#line 381
;
	do {pushs(env, mp->buf);
#line 382
return;
#line 382
} while (0);
}
}


#line 386
void
#line 386
msg_init_builtin()
#line 386
{
#line 386
	#line 36 "bi_msg.m4"
MSGTAB_id = builtin_priv_register(alloc_msgs, destroy_msgs);
#line 136 "bi_msg.m4"
va_builtin_install_ex("message_close", bi_message_close, 0, 0, dtype_unspecified, 1, 0, 0, dtype_number);
#line 144 "bi_msg.m4"
va_builtin_install_ex("message_lines", bi_message_lines, 0, 0, dtype_number, 1, 0, 0, dtype_number);
#line 160 "bi_msg.m4"
va_builtin_install_ex("message_body_lines", bi_message_body_lines, 0, 0, dtype_number, 1, 0, 0, dtype_number);
#line 179 "bi_msg.m4"
va_builtin_install_ex("message_header_lines", bi_message_header_lines, 0, 0, dtype_number, 1, 0, 0, dtype_number);
#line 195 "bi_msg.m4"
va_builtin_install_ex("message_header_count", bi_message_header_count, 0, 0, dtype_number, 1, 0, 0, dtype_number);
#line 211 "bi_msg.m4"
va_builtin_install_ex("message_has_header", bi_message_has_header, 0, 0, dtype_number, 3, 1, 0, dtype_number, dtype_string, dtype_number);
#line 224 "bi_msg.m4"
va_builtin_install_ex("message_find_header", bi_message_find_header, 0, 0, dtype_string, 3, 1, 0, dtype_number, dtype_string, dtype_number);
#line 244 "bi_msg.m4"
va_builtin_install_ex("message_is_multipart", bi_message_is_multipart, 0, 0, dtype_number, 1, 0, 0, dtype_number);
#line 259 "bi_msg.m4"
va_builtin_install_ex("message_count_parts", bi_message_count_parts, 0, 0, dtype_number, 1, 0, 0, dtype_number);
#line 274 "bi_msg.m4"
va_builtin_install_ex("message_get_part", bi_message_get_part, 0, 0, dtype_number, 2, 0, 0, dtype_number, dtype_number);
#line 297 "bi_msg.m4"
va_builtin_install_ex("message_rewind", bi_message_rewind, 0, 0, dtype_unspecified, 1, 0, 0, dtype_number);
#line 316 "bi_msg.m4"
va_builtin_install_ex("message_read_line", bi_message_read_line, 0, 0, dtype_string, 1, 0, 0, dtype_number);
#line 342 "bi_msg.m4"
va_builtin_install_ex("message_body_rewind", bi_message_body_rewind, 0, 0, dtype_unspecified, 1, 0, 0, dtype_number);
#line 361 "bi_msg.m4"
va_builtin_install_ex("message_read_body_line", bi_message_read_body_line, 0, 0, dtype_string, 1, 0, 0, dtype_number);

#line 386 "bi_msg.m4"
		
#line 386
}
#line 550 "../mfd/snarf.m4"

#line 550

